package ru.dbotthepony.kstarbound.world.api

import ru.dbotthepony.kstarbound.Registry
import ru.dbotthepony.kstarbound.defs.tile.BuiltinMetaMaterials
import ru.dbotthepony.kstarbound.defs.tile.MaterialModifier
import ru.dbotthepony.kstarbound.defs.tile.TileDefinition
import java.io.DataInputStream

sealed class AbstractTileState {
	abstract val material: Registry.Entry<TileDefinition>
	abstract val modifier: Registry.Entry<MaterialModifier>?
	abstract val color: TileColor
	abstract val hueShift: Float
	abstract val modifierHueShift: Float

	abstract fun immutable(): ImmutableTileState
	abstract fun mutable(): MutableTileState

	companion object {
		fun skip(stream: DataInputStream) {
			stream.skipNBytes(2 + 1 + 1 + 2 + 1)
		}

		val EMPTY = ImmutableTileState(BuiltinMetaMaterials.EMPTY)
		val NULL = ImmutableTileState(BuiltinMetaMaterials.NULL)
	}
}
